from PyQt5 import QtCore
from PyQt5.QtCore import Qt, QMimeData

def decode_data(bytearray):

    '''
    Gets the items in the original list box for all the items being dragged.
    '''

    data = []
    item = {}

    #print("decode_data")
    ds = QtCore.QDataStream(bytearray)
    #print(f"ds = {ds}")
    while not ds.atEnd():

        row = ds.readInt32()
        column = ds.readInt32()
        #print(f"ROW {row}, COL {column}")
        map_items = ds.readInt32()
        #print(f"map_items = {map_items}")
        for i in range(map_items):
            key = ds.readInt32()
            #print(f"key = {key}")
            value = QtCore.QVariant()
            #print(f"value = {value}")
            ds >> value
            #print(f"ds >> value : {ds}")
            item[Qt.ItemDataRole(key)] = value
            #print(f"value now = {value}")
        data.append(item)
    return data

def get_rows(bytearray):

    '''
    Gets the row numbers in the original list box for all the items being dragged.
    '''

    data = []
    item = {}

    #print("get_rows")
    ds = QtCore.QDataStream(bytearray)
    #print(f"ds = {ds}")
    while not ds.atEnd():
        row = ds.readInt32()
        column = ds.readInt32()
        map_items = ds.readInt32()
        for i in range(map_items):
            key = ds.readInt32()
            value = QtCore.QVariant()
            ds >> value
            item[Qt.ItemDataRole(key)] = value
        data.append(row)
        #print(f"ROW {row}, COL {column}")
    return data

