title: VIS IWS HK Parameter Chooser
author: M.Whillock@ucl.ac.uk
date: 23 Apr 2020

Copyright © 2020 University College London / MSSL

--


# Introduction


This a mini user guide to the VIS IWS TM HK Playback (hk_playback.py) program.

## Prerequisites

* python3
* git

## Installation: Online Deployment

TBD

## Installation: Offline Deployment

The HK Playback program is currently bundled in with the TM HK Monitor program.

If this has not alrady been done then choose a location to untar the HKTM_monitor gzipped tar file and untar it.

`tar xvfz HKTM_monitor.tar.gz`

Change directory into the new directory:

`cd HKTM_monitor`


## HK Playback

This program requires the conda environment IWSop to be set:

`conda activate IWSop`

### Launching

The program is launched via the HK Control Centre program (see ***hk\_cc\_um.pdf***).

Once launched from the HK Control Centre the main window will appear:

![hk_playback.py main window](../Pictures/hk_playback/hk_playback.png)

with a number of blank graphs and date time controls.


### Operation

The bottom-left text label indicates the configuration file selected in the HK Control Centre.
The bottom-right text label shows the data file to be plotted, selected in the HK Control Centre program.

The ***From:*** and ***To:*** date time selectors at the top-left of the window are set to the start and end date time of the file as determined by the ***Catalog*** function in the HK Control Centre.
Before plotting the data the user has an opportunity to modify these date/times.
Clicking the ***Playback HKTM*** button will plot the data according to the format requested in the configuration file.
A message will appear next to the ***Playback HKTM*** button while the program is reading the data.

![hk_playback_read](../Pictures/hk_playback/hk_playback2.png)

If errors are encountered during reading or plotting the data an error message will be displayed next to the ***Playback HKTM*** button.
Errors encountered during the plotting process will result in blank graphs.

A successful plot is shown below:

![hk_playback_plot](../Pictures/hk_playback/hk_playback1.png)


The data can be re-plotted as many times as required be clicking the ***Playback HKTM*** button. The ***From:*** and ***To:*** datetime controls can be changed between plots to alter the granularity of the plots.

Pressing the ***Quit*** button will close the window and exit the program.
The ***HK Control Centre*** program will continue running.

#### Limitations

- Parameters plotted on the same graph must have the same generation rate (i.e. all be from the same packet type, such as rt_slow for example).


#### Future Work

- Incorporate limit lines.
- Incorporate event indicators.
- Allow a mix of parameters from different rates to be plotted on the same graph.
