import os, sys

from PyQt5 import QtWidgets, QtCore, QtGui      #, uic, QtQml, QtQuick
from PyQt5.QtCore import Qt

""" his modules provides a method for making a parameter display box."""

PARAMETER_LABEL_XSTART = 5
LABEL_YSTART           = 30 #5
#PARAMETER_LABEL_WIDTH  = 190
#VALUE_LABEL_WIDTH      = 139
PARAMETER_LABEL_WIDTH  = 150
VALUE_LABEL_WIDTH      = 78
LABEL_HEIGHT           = 16
OFFSET                 = LABEL_HEIGHT + 2
#INTER_COLUMN_GAP       = 5
INTER_COLUMN_GAP       = 8

FULL_WIDTH = PARAMETER_LABEL_XSTART + PARAMETER_LABEL_WIDTH + VALUE_LABEL_WIDTH
PWIDTH     = PARAMETER_LABEL_XSTART + PARAMETER_LABEL_WIDTH
VWIDTH     = VALUE_LABEL_WIDTH

PARAMETER_LABEL = 0
VALUE_LABEL     = 1

#class DisplayBox(object):

def label_key_origin(row):
    return(FULL_WIDTH + (4 * INTER_COLUMN_GAP), (1.85 * LABEL_YSTART) + (row * OFFSET) - (LABEL_HEIGHT / 2))

#@classmethod
def foo():
    print("Class method foo called\n")

    
#@classmethod
def make_box(owner, column, ypos, name):
    """ Makes 2 Qlabels, 1 for the parameter label and one for the parameter value.
    Assigns the same stylesheet to both.
    Returns the QLables in a tuple."""

    style_sheet = \
    "QLabel[stat=warn] {background-color: yellow; color: black;} " +  \
    "QLabel[stat=ok] {background-color: green; color: white;} " + \
    "QLabel[stat=ool] {background-color: red; color: white}"

    # Label box
    label = QtWidgets.QLabel(owner)
    label.setContentsMargins(5,0,0,0)
    label.setStyleSheet(style_sheet)
    label.setProperty('stat', 'ok')
    label.setGeometry(QtCore.QRect((column * FULL_WIDTH) + INTER_COLUMN_GAP, LABEL_YSTART + (ypos * OFFSET), PARAMETER_LABEL_WIDTH, LABEL_HEIGHT))
    label.setObjectName(name)
    label.setText(name)
    ###label.setToolTip("Tooltip")

    # Value box
    value = QtWidgets.QLabel(owner)
    #value.setMargin(5)
    value.setContentsMargins(0,0,5,0)
    value.setStyleSheet(style_sheet)
    value.setProperty('stat', 'ok')
    value.setGeometry(QtCore.QRect(((column + 1) * PWIDTH) + (column * VWIDTH), LABEL_YSTART + (ypos * OFFSET), VALUE_LABEL_WIDTH, LABEL_HEIGHT))
    value.setObjectName(name + "Value")
    value.setText("Value")
    value.setAlignment(QtCore.Qt.AlignRight|QtCore.Qt.AlignTrailing|QtCore.Qt.AlignVCenter)

    font = QtGui.QFont()
    font.setPointSize(6)
    font.setBold(True)
    font.setWeight(75)
    label.setFont(font)
    value.setFont(font)

    return (label, value)
